#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "M_ActivitySummerMissionCFG.h"
#include "FileEncrypt.h"
std::auto_ptr<M_ActivitySummerMissionCFG> M_ActivitySummerMissionCFG::msSingleton(nullptr);

int M_ActivitySummerMissionCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_ActivitySummerMissionCFGData* M_ActivitySummerMissionCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, M_ActivitySummerMissionCFGData>& M_ActivitySummerMissionCFG::GetMapData()
{
	return mMapData;
}

void M_ActivitySummerMissionCFG::Reload()
{
	mMapData.clear();
	Load();
}

void M_ActivitySummerMissionCFG::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ActivitySummerMissionCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mName = element->Attribute("Name");
		data.mCompleteType = element->IntAttribute("CompleteType");
		{
			const char* CompleteParam = element->Attribute("CompleteParam");
			std::vector<std::string> vecCompleteParam;
			boost::split(vecCompleteParam, CompleteParam, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecCompleteParam.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecCompleteParam[i].c_str(), &temp))
				{
					data.mCompleteParam.push_back(temp);
				}
			}
		}
		data.mCompleteCount = element->IntAttribute("CompleteCount");
		{
			const char* RewardItem = element->Attribute("RewardItem");
			std::vector<std::string> vecRewardItem;
			boost::split(vecRewardItem, RewardItem, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecRewardItem.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecRewardItem[i].c_str(), &temp))
				{
					data.mRewardItem.push_back(temp);
				}
			}
		}
		{
			const char* RewardQuantity = element->Attribute("RewardQuantity");
			std::vector<std::string> vecRewardQuantity;
			boost::split(vecRewardQuantity, RewardQuantity, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecRewardQuantity.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecRewardQuantity[i].c_str(), &temp))
				{
					data.mRewardQuantity.push_back(temp);
				}
			}
		}
		data.mGoType = element->IntAttribute("GoType");
		{
			const char* FindRand = element->Attribute("FindRand");
			std::vector<std::string> vecFindRand;
			boost::split(vecFindRand, FindRand, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecFindRand.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecFindRand[i].c_str(), &temp))
				{
					data.mFindRand.push_back(temp);
				}
			}
		}
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		assert(mMapData.find(data.mID) == mMapData.end());
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
}

void M_ActivitySummerMissionCFG::Load()
{
	Load("../Config/M_ActivitySummerMissionCFG.xml");
}

M_ActivitySummerMissionCFG* M_ActivitySummerMissionCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ActivitySummerMissionCFG());
	}
	return msSingleton.get();
}
